# Leaflet Plugins

<table class="form-table" border="1">
<thead><tr><th style="text-align:center">Function</th><th style="text-align:center">Shortcode(s) / Function</th><th style="text-align:center">Leaflet Plugins</th></tr></thead>
<tbody>

<tr><td colspan="3" style="text-align:center"><b>Elevation Profile</b></td></tr>
<tr><td>track with an elevation profile</td><td>elevation
<td><a href="https://github.com/Raruto/leaflet-elevation">leaflet-elevation</a>, <a href="https://github.com/yohanboniface/Leaflet.i18n">Leaflet.i18n</a></td></tr>

<tr><td>multiple tracks with elevation profiles</td><td>elevation-track, elevation-tracks, multielevation
<td><a href="https://github.com/Raruto/leaflet-elevation">leaflet-elevation</a>, <a href="https://github.com/makinacorpus/Leaflet.GeometryUtil">Leaflet.GeometryUtil</a></td></tr>

<tr><td colspan="3" style="text-align:center"><b>Functions for Markers</b></td></tr>

<tr><td>marker clustering</td><td>cluster</td><td><a href="https://github.com/Leaflet/Leaflet.markercluster">Leaflet.markercluster</a></td></tr>

<tr><td>clustering and grouping of markers</td><td>markerClusterGroup</td><td><a href="https://github.com/ghybs/Leaflet.FeatureGroup.SubGroup">Leaflet.FeatureGroup.SubGroup</a></td></tr>

<tr><td>styling markercluster</td><td>placementstrategies</td><td><a href="https://github.com/adammertel/Leaflet.MarkerCluster.PlacementStrategies">Leaflet.MarkerCluster.PlacementStrategies</a></td></tr>

<tr><td>more markers</td><td>leaflet-extramarker</td><td><a href="https://github.com/coryasilva/Leaflet.ExtraMarkers">Leaflet.ExtraMarkers</a></td></tr>

<tr ><td>hide markers</td><td>hidemarkers</td><td></td></tr>

<tr><td colspan="3" style="text-align:center"><b>Further Leaflet Plugins</b></td></tr>

<tr><td>Grouping by options and features</td><td>leaflet-optiongroup, leaflet-featuregroup</td><td><a href="https://github.com/ghybs/Leaflet.FeatureGroup.SubGroup">Leaflet.FeatureGroup.SubGroup</a></td></tr>

<tr><td>Search markers/features</td><td>leaflet-search</td><td><a href="https://github.com/stefanocudini/leaflet-search">Leaflet Control Search</a></td></tr>

<tr><td>Leaflet Choropleth</td><td>choropleth</td><td><a href="https://github.com/timwis/leaflet-choropleth">Leaflet Choropleth</a></td></tr>

<tr><td>switching tile servers</td><td>layerswitch</td><td><a href="https://leafletjs.com/examples/layers-control/">L.control.layers</a>, <a href="https://github.com/leaflet-extras/leaflet-providers">Leaflet-providers</a>, <a href="https://github.com/dayjournal/Leaflet.Control.Opacity">Leaflet.Control.Opacity</a></td></tr>

<tr><td>reset the map</td><td>zoomhomemap</td><td><a href="https://github.com/torfsen/leaflet.zoomhome">leaflet.zoomhome</a></td></tr>

<tr><td>fullscreen</td><td>fullscreen</td><td><a href="https://github.com/brunob/leaflet.fullscreen">leaflet.fullscreen</a></td></tr>

<tr><td>gesture handling</td><td>gestures</td><td><a href="https://github.com/Raruto/leaflet-gesture-handling">Leaflet.GestureHandling</a></td></tr>

<tr><td colspan="3" style="text-align:center"><b>Files for Leaflet Map</b></td></tr>

<tr><td>Files for Leaflet Map</td><td>Files for Leaflet Map</td><td></td></tr>

<tr><td>Tracks from all files in a directory</td><td>leaflet-directory</td><td></td></tr>

<tr><td colspan="3" style="text-align:center"><b>More Functions</b></td></tr>

<tr><td>Hovering and Tooltips</td><td>hover</td><td></td></tr>

<tr><td>Migration from <a href="https://wordpress.org/plugins/wp-gpx-maps/">WP GPX Maps</a></td><td>sgpx</td><td></td></tr>

</tbody></table>
